// TestTriangleArea.c

#include "unity.h"
#include "TriangleArea.h"
#include "CException.h"
#include "ErrorCode.h"

void setUp(void)
{
}

void tearDown(void)
{
}

void test_TriangleArea_3_4_5_Equals_6(void)
{
     //  1 - 
     double const expected = 6.0;
     //  2 - 
     double actual = triangleArea(3.0, 4.0, 5.0);
     //  3 - 
     TEST_ASSERT_EQUAL_FLOAT(expected, actual);
     //  4 - 
}

static void callTriangleAreaAndCheckException(
       double a, double b, double c, CEXCEPTION_T ce)
{
     CEXCEPTION_T e;
     Try
     {
             triangleArea(a, b, c);
             TEST_FAIL_MESSAGE("No exception was thrown");
     }
     Catch(e)
     {
             TEST_ASSERT_EQUAL_UINT((unsigned int)ce, (unsigned int)e);
     }
}

void test_Side_1_isLessThan_0_Exception(void)
{
     callTriangleAreaAndCheckException(-3.0, 4.0, 5.0, INVALID_SIDE);
}

void test_Side_2_isLessThan_0_Exception(void)
{
     callTriangleAreaAndCheckException(3.0, -4.0, 5.0, INVALID_SIDE);
}

void test_Side_3_isLessThan_0_Exception(void)
{
     callTriangleAreaAndCheckException(3.0, 4.0, -5.0, INVALID_SIDE);
}

void test_Side_1_isEqual_0_Exception(void)
{
     callTriangleAreaAndCheckException(0.0, 4.0, 5.0, INVALID_SIDE);
}

void test_Side_2_isEqual_0_Exception(void)
{
     callTriangleAreaAndCheckException(3.0, 0.0, 5.0, INVALID_SIDE);
}

void test_Side_3_isEqual_0_Exception(void)
{
     callTriangleAreaAndCheckException(3.0, 4.0, 0.0, INVALID_SIDE);
}

void test_Side_1_isTooLong_Exception(void)
{
     callTriangleAreaAndCheckException(10.0, 1.0, 1.0, BAD_TRIANGLE);
}

void test_Side_2_isTooLong_Exception(void)
{
     callTriangleAreaAndCheckException(1.0, 10.0, 1.0, BAD_TRIANGLE);
}

void test_Side_3_isTooLong_Exception(void)
{
     callTriangleAreaAndCheckException(1.0, 1.0, 10.0, BAD_TRIANGLE);
}

void test_TriangleArea_Height_is_0(void)
{
     //  1 - 
     double const expected = 0.0;
     //  2 - 
     double actual = triangleArea(1.0, 1.0, 2.0);
     //  3 - 
     TEST_ASSERT_EQUAL_FLOAT(expected, actual);
     //  4 - 
}
